您的位置:首页 > 其它

Codeforces-798D. Mike and distribution

2017-05-10 21:54 465 查看
D. Mike and distribution
time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
Mike has always been thinking about the harshness of social inequality. He's so obsessed with it that sometimes it even affects him while solving problems. At the moment, Mike has two sequences of positive integers A = [a1, a2, ..., an] and B = [b1, b2, ..., bn] of length n each which he uses to ask people some quite peculiar questions.

To test you on how good are you at spotting inequality in life, he wants you to find an "unfair" subset of the original sequence. To be more precise, he wants you to select k numbers P = [p1, p2, ..., pk] such that 1 ≤ pi ≤ n for 1 ≤ i ≤ k and elements in P are distinct. Sequence P will represent indices of elements that you'll select from both sequences. He calls such a subset P "unfair" if and only if the following conditions are satisfied: 2·(ap1 + ... + apk) is greater than the sum of all elements from sequence A, and 2·(bp1
4000
 + ... + bpk) is greater than the sum of all elements from the sequence B. Also, k should be smaller or equal to  because it will be to easy to find sequence P if he allowed you to select too many elements!

Mike guarantees you that a solution will always exist given the conditions described above, so please help him satisfy his curiosity!

Input
The first line contains integer n (1 ≤ n ≤ 105) — the number of elements in the sequences.

On the second line there are n space-separated integers a1, ..., an (1 ≤ ai ≤ 109) — elements of sequence A.

On the third line there are also n space-separated integers b1, ..., bn (1 ≤ bi ≤ 109) — elements of sequence B.

Output
On the first line output an integer k which represents the size of the found subset. k should be less or equal to .

On the next line print k integers p1, p2, ..., pk (1 ≤ pi ≤ n) — the elements of sequence P. You can print the numbers in any order you want. Elements in sequence P should be distinct.

Example
input
5
8 7 4 8 3
4 2 5 3 7
output
3
1 4 5


脑洞略大

2∗∑ki=1a[pk]>∑ni=1a[i]=>∑ki=1a[pk]>∑ni=1a[i]−∑ki=1a[pk]

因为a[i]>0,显然贪心地选择k=n2+1最优

问题转化为:n个数选择n2+1个数,其和值大于未被选择的数的和

按a[i]从大到小排序,得到下标集合idx

当n%2==1:

选择idx[1] (此时a[idx[1]]是a中最大的)

然后以2个数为一组

选择{idx[2],idx[3]}中b更大的一个

依次选择{idx[i],idx[i+1]}

假如选择了idx[3],idx[5],idx[8].....

a[idx[1]]−a[idx[2]]>0,a[idx[3]]−a[idx[6]]>0,a[idx[5]]−a[idx[8]]>0.....

所以对数组a,选择的数和值必然大于未被选择的数和值

而数组b每次选择较大的一个,显然也满足

n%2==0时类似

选择a[idx[1],a[idx[n]],对中间部分,每次选择b较大的

#include<stdio.h>
#include <iostream>
#include<stdlib.h>
#include<algorithm>
#include<vector>
#include<deque>
#include<map>
#include<set>
#include<queue>
#include<math.h>
#include<string.h>
#include<string>

using namespace std;
#define ll long long
#define pii pair<int,int>

const int inf = 1e9 + 7;

const int N = 1e5+5;

int a
;
int idx
;
int b
;

bool cmpIdx(int x,int y){
return a[x]>a[y];
}

void slove(int n){
for(int i=1;i<=n;++i){
idx[i]=i;
}
sort(idx+1,idx+n+1,cmpIdx);
printf("%d\n%d",n/2+1,idx[1]);
for(int i=2;i+1<=n;i+=2){
int x=idx[i],y=idx[i+1];
int ansIdx=b[x]>b[y]?x:y;
printf(" %d",ansIdx);
}
if(n%2==0){
printf(" %d",idx
);
}
putchar('\n');
}

int main()
{
//freopen("/home/lu/Documents/r.txt","r",stdin);
//freopen("/home/lu/Documents/w.txt","w",stdout);
int n;
while(~scanf("%d",&n)){
for(int i=1;i<=n;++i){
scanf("%d",a+i);
}
for(int i=1;i<=n;++i){
scanf("%d",b+i);
}
slove(n);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  codeforces 贪心